Description

I'm just trying to use QGIS as another GIS platform for our product suite (in addition to ArcGIS, AutoCAD Map, GeoMedia, ...).

We use MSSQL and Oracle as DBMS backend, and I have problems with MSSQL.

I would like to use a SELECT statement as data source. This seems to be possible with postgres, but it's not possible with MSSQL,

because the "table=dbo.tablename"-part of the data source must have this exact format. In postgres it's possible to use "table=(SELECT

... FROM xyz)". I don't know if this is a bug or if I should create a feature request ;-)

For now it's ok to use a view instead of a SELECT statement as data source, and this works in principle ("table=dbo.viewname").

In this case I have to set "key=primarykeycolumn" in the data source, so that each row is identifiable.

Our primary key-columns are of type "char", and this does not work for the MSSQL (but it does for Oracle).

SQL Profiler told me, that "int" seems to be the required type for the key columns, because every SQL statement contains a "0" as primary

key value.

I've also noticed that "STIntersects()" is used to query the currently visible elements - I think you should consider using "Filter()" to get

(much) better performance.

Markus

Related issues:

Related to QGIS Application - Bug report # 9007: MS SQL uniqueidentifier data... Closed 2013-11-04

Related to QGIS Application - Feature request # 12324: QGIS 2.8 Wien - Crashe... Closed 2015-03-05

Duplicated by QGIS Application - Bug report # 12837: QGIS Crashing When Conne... Closed 2015-05-28

History

#1 - 2014-07-24 03:15 PM - Jürgen Fischer

- Tracker changed from Bug report to Feature request

#2 - 2014-07-24 03:37 PM - Nathan Woodrow

I've also noticed that "STIntersects()" is used to query the currently visible elements - I think you should consider using "Filter()" to get (much)

better performance.

Can you open a new ticket for this.

#3 - 2014-07-24 03:50 PM - Markus Woehling

I've opened two new tickets #11076 and #10948
#4 - 2015-03-06 04:51 AM - Jürgen Fischer

Support for arbitrary keys was added to the postgresql provider in commit:ce4fc1da.  The oracle provider also implements pktFidMap type keys.

#5 - 2015-05-31 10:22 PM - Nathan Woodrow

- Assignee set to Nathan Woodrow

#6 - 2015-08-31 12:39 PM - Ali Diba

You should allow for supporting Global Unique ID which is a unique 16 byte number. This is refereed to as GUID and UNIQUEIDENTIFIER within the SQL

Server community. GUIDs are very important when it comes to data collection from multiple disconnected devices. This is the only way to guarantee

merging of the data from all devices while avoiding conflicts.

#7 - 2017-05-01 12:47 AM - Giovanni Manghi

- Easy fix? set to No
